# <trigger>
#	<usage>perl createRelation.pl relationName attributeName relationType</usage>
#	<version>4.3</version>
#	<description>创建从 attributeName 参数中的 CR 到触发该脚本的 CR 的关系。
#		attributeName 参数包含转变中某个属性的名称，该属性包含 RCR 对象的 CR 号。   </description>
#	<argument1>
#		<name>relation</name>
#		<required>true</required>
#		<type></type>
#		<description>要在 CR 之间创建的关系的名称</description>
#	</argument1>
#	<argument2>
#		<name>attributeName</name>
#		<required>true</required>
#		<type></type>
#		<description>包含 CR 号的属性的名称。</description>
#   </argument2>
#	<argument3>
#		<name>rel_type</name>
#		<required>true</required>
#		<type></type>
#		<description>要创建的关系的类型。可能的值有：problem_problem、problem_task、problem_object、task_task、task_object 和 object_object</description>
#	</argument3>
# </trigger>
use utf8;
use ChangeSynergy::TriggerParser;
use ChangeSynergy::csapi;

my $relation = shift;
my $relation_attr = shift;
my $rel_type = shift;

#Create a new TriggerParser object
my $trigger = new ChangeSynergy::TriggerParser($ARGV[-1]);

my %attributes = $trigger->get_attributes();
my $create = $attributes{$relation_attr};

if ((!defined($create)) || ("\L$create" eq ""))
{
	exit 0;
}

#Create new csapi object
my $csapi = new ChangeSynergy::csapi();
my $fromObject   = $trigger->get_object_id();

#setup the connection
$csapi->setUpConnection($trigger->get_base_url());

#create a user object
my $user = new ChangeSynergy::apiUser($trigger->get_user(), "password", $trigger->get_role(),
					$trigger->get_token(), $trigger->get_database());

#verify that the target object exists.
#Create a query string and then call the api to get a data report.
my $queryString = "problem_number='" . $create . "'";
my $data = $csapi->QueryData($user, "Basic Summary", $queryString, undef, undef, undef);

if ($data->getDataSize() == 0) {
	die "Unable to create relation, CR " . $create . " does not exist\n";
}

my $tmpstr = $csapi->CreateRelation($user, "FALSE", $create, $fromObject, $relation, $rel_type);
print "Created $relation relationship between $fromObject and $create\n";
exit 0;
